typedef struct _Node
{
        void            *data;
        struct _Node    *next;
} node;

typedef struct _Queue
{
        int        queue_sz;
        size_t     mem_sz;
        node      *head;
        node      *tail;
} queue;

void        init_queue(queue *, size_t);
void        free_queue(queue *);
void        dequeue(queue *, void *);
int         enqueue(queue *, const void *);
int         check_queue_sz(queue *);
